// Commit Stage rule...
rule display_trace_info ((phase == 6));
	$display("%x  |  %x  {%x %x}  {%x %x %x %x %x %x}  {%x %x}  {%x %x %x}  {%x %x %x}  {%x %x %x}  {%x %x %x}  |  %x", cycle, auth, pcu.get_pc.meta.tag, pcu.get_pc.a, 
												ci.meta.tag, ci.opcode, ci.src1, ci.src2, ci.dest, ci.imm,
												ren || wen, ma.a,
												op1.meta.ag, op1.meta.tag, op1.payload, 
												op2.meta.ag, op2.meta.tag, op2.payload, 
												op3.meta.ag, op3.meta.tag, op3.payload, 
												mr.meta.ag, mr.meta.tag, mr.payload,
                                                                                                (error_code == NO_ERROR) && tmu_allow ? NO_ERROR :
                                                                                                error_code != NO_ERROR  ? error_code : TMU_FAULT);
endrule


rule commit_error (proc_enabled && ((error_code != NO_ERROR) || !tmu_allow) &&
                   (phase == 6));
        //trap handler...
        if (error_code != NO_ERROR)
                state[valueOf(TS)] <= unpack(extend(pack(ThreadStatus{thread_state: thread_state, error_code: error_code})));
	else
                state[valueOf(TS)] <= unpack(extend(pack(ThreadStatus{thread_state: FAULTED, error_code: TMU_FAULT})));

        state[valueOf(FPC)] <= unpack(pack(pcu.get_pc));
        state[valueOf(FA)] <= unpack(pack(auth));
        state[valueOf(MR)] <= curr_mr;
        fTP <= tp;
        dunder_ftp <= dunder_tp;
        dover_ftp <= dover_tp;
        tmp_tp <= tp;
        dunder_tmp_tp <= dunder_tp;
        dover_tmp_tp <= dover_tp;
        write_buffer.reset_wb;
        //load in the new pc for ucode
        pcu.change_pc(ucode_fault_pc, ucode_fault_dunder, ucode_fault_dover);
        use_ucode <= True;
        ucode.a.put(False, ucode_fault_pc.a, ?);
        in_trans <= False;
        cycle <= cycle + 1;
endrule

rule commit_normal (proc_enabled && ((error_code == NO_ERROR) && tmu_allow) &&
                    (phase == 6));
        RegAtom writeback1 = ?;
        RegAtom writeback2 = ?;
        if ((decoder_out.op == STWB) || (decoder_out.op == STWY) ||
            (decoder_out.op == STRB) || (decoder_out.op == STRY))
                begin //STxx
                        FatPointer new_ptr;
                        GPR new_dest;
                        if ((decoder_out.op == STWB) || (decoder_out.op == STWY)) begin
                                new_ptr = tpl_2(fpu_out);
                                new_dest = decoder_out.src2;
                                writeback1 = RegAtom{atom: unpack(pack(new_ptr)), dunder: dunder, dover: dover};
                                rf.write_port1(extend(pack(new_dest)), writeback1);
                        end
                        else begin //STRx
                                new_ptr = tpl_2(fpu_out);
                                new_dest = decoder_out.src1;
                                writeback1 = RegAtom{atom: unpack(pack(new_ptr)), dunder: dunder, dover: dover};
                                writeback2 = RegAtom{atom: result_atom, dunder: dunder_mem, dover:dover_mem};
                                rf.write_port1(extend(pack(new_dest)), writeback1);
                                rf.write_port2(extend(pack(decoder_out.dest)), writeback2);
                        end
                end
        else if (is_offset_ptr || (decoder_out.op == REGRP) || (decoder_out_p0.op == MVRR) || (decoder_out_p0.op == CPRR)) begin
                writeback1 = RegAtom{atom: result_atom, dunder: dunder, dover: dover};
                rf.write_port1(zeroExtend(pack(decoder_out.dest)), writeback1);
        end
        else if (decoder_out.op == MVRM) begin
                Atom write_atom = Atom{meta: MetaData{ag: UNINITIALIZED,
                                                      tag: unpack(extend(tmu_out.op1res))},
                                       payload: 0};
                writeback2 = RegAtom{atom: write_atom, dunder: dunder, dover: dover};
                rf.write_port2(zeroExtend(pack(decoder_out.src1)), writeback2);
        end
        else if (default_commit) begin //sd,ssd,lcfp,rdtime
                writeback1 = RegAtom{atom: result_atom, dunder: dunder_mem, dover: dover_mem};
                rf.write_port1(zeroExtend(pack(decoder_out.dest)), writeback1);
                if (decoder_out.op == MVRR) begin  //clear rf for mvrx
                        Atom write_atom = Atom{meta: MetaData{ag: UNINITIALIZED,
                                                              tag: unpack(extend(tmu_out.op1res))},
                                               payload: 0};
                        writeback2 = RegAtom{atom: write_atom, dunder: dunder, dover: dover};
                        rf.write_port2(zeroExtend(pack(decoder_out.src1)), writeback2);
                end
        end
        else if (decoder_out.op == SETA)
                state[valueOf(AUTH)] <= unpack(pack(result_atom));
        else if (is_gate_insn)
                begin
                        let gate = curr_line;
                        state[valueOf(AUTH)] <= (decoder_out.op == GACALL) || (decoder_out.op == BGACALL) ?
			                         unpack(extend(pack(tmu_out.auth))): unpack(pack(gate.a1));
                        //write the env pointer for the new gate into
                        ep <= unpack(pack(gate.a2));
                        writeback1 = RegAtom{atom: unpack(pack(gate.a2)), dunder: dunder_mem, dover: dover_mem};                        
                        rf.write_port1(0, writeback1);
                        if ((decoder_out.op != GRTN) && (decoder_out.op != BRTN)) begin
				writeback2 = RegAtom{atom: result_atom, dunder: dunder, dover: dover};
				rf.write_port2(zeroExtend(pack(decoder_out.src1)), writeback2);
			end
		end
        else if (decoder_out.op == TRANSBEGIN) begin
                trans_pc <= pc;
                in_trans <= True;
        end
        else if (decoder_out.op == TMUU)
                tmu.tmu_unload(unpack(truncate(pack(op1.payload))));
        else if (decoder_out.op == TMUL)
                tmu.tmu_load(unpack(truncate(pack(op1.payload))),
                             unpack(truncate(pack(op2.payload))),
                             unpack(truncate(pack(op3.payload))));
        else if (decoder_out.op == RDFHTP) begin
                new_tp <= fhtp;
                dunder_new_tp <= dunder_mem;
                dover_new_tp <= dover_mem;
                writeback1 = RegAtom{atom: unpack(0), dunder: unpack(0), dover: unpack(0)};
                rf.write_port2(itt_addr, writeback1);
        end
        else if (decoder_out.op == SETFHTP) begin
                writeback1 = RegAtom{atom: unpack(pack(tp)), dunder: dunder_tp, dover: dover_tp};
                rf.write_port2(itt_addr, writeback1);
        end
        else if (use_ucode && (decoder_out.op == CPMP)) begin
                Bit#(6) dest = truncate(decoder_out.imm);
                writeback1 = RegAtom{atom: result_atom, dunder: dunder_mem, dover: dover_mem};
                if (dest == 1) begin
                        if (ts.thread_state == FAULTED) begin
                                writeback1 = RegAtom{atom: unpack(pack(fTP)), dunder: dunder_ftp, dover: dover_ftp};
                        end
                        rf.write_port1(1, writeback1);
                end
                else if (dest < 48)
                        rf.write_port1(unpack(truncate(dest)), writeback1);
                else
                        state[dest - 48] <= writeback1.atom;
                if (dest == 0)
                        ep <= unpack(pack(writeback1.atom));
                if (dest == 48) begin
                        //need to keep the dunder/over around to load later
                        dunder_pc <= dunder_mem;
                        dover_pc <= dover_mem;
                end
                if (dest == 51)
                        gate_stack.set_gsp(unpack(pack(writeback1.atom)), dunder_mem, dover_mem);
                tmp_tp <= tpl_2(fpu_out);
                dunder_tmp_tp <= dunder;
                dover_tmp_tp <= dover;
        end
        else if (use_ucode && (decoder_out.op == CPPM)) begin
                Bit#(6) dest = truncate(decoder_out.imm);
                if (dest != 63) begin
                        tmp_tp <= tpl_2(fpu_out);
                        dunder_tmp_tp <= dunder;
                        dover_tmp_tp <= dover;
                end
                else begin
                        tmp_tp <= new_tp;
                        dunder_tmp_tp <= dunder_new_tp;
                        dover_tmp_tp <= dover_new_tp;
                end
        end
	
	if (decoder_out.op == BRTN) begin
		let tmp_lm = live_mask;
		tmp_lm = tmp_lm & (~write_mask);
		tmp_lm[pack(decoder_out.src1)] = 1;
		live_mask <= tmp_lm;
		write_mask <= truncate(pack(curr_line.a3)) >> 32;
	end
	else if (is_bracket_insn) begin
		write_mask <= write_mask & truncate(pack(op3));
	end
	
        //potential pc changers
        FatPointer ucode_pc = ?;
        if ((decoder_out.op == GCALL) || (decoder_out.op == GACALL) ||
            (decoder_out.op == GJMP) || (decoder_out.op == GAJMP) ||
            (decoder_out.op == GRTN))
                begin
                        gate_stack.update_gsp(decoder_out.op);
                        pcu.set_pc;
                end
        else if ((decoder_out.op == CALL) || (decoder_out.op == FJMP) || (decoder_out.op == BCALL)) begin
                gate_stack.update_gsp(decoder_out.op);
                pcu.set_pc;
        end
        //changes to ucode pc
        else if (decoder_out.op == RUNT) begin
                use_ucode <= True;
                ucode_pc = ucode_runt_pc;
                pcu.change_pc(ucode_runt_pc, ucode_runt_dunder, ucode_runt_dover);
                old_tp <= tp;
                tmp_tp <= unpack(pack(op1));
                dunder_tmp_tp <= op1_dunder;
                dover_tmp_tp <= op1_dover;
                new_tp <= unpack(pack(op1));
                dunder_new_tp <= op1_dunder;
                dover_new_tp <= op1_dover;
        end
        else if (decoder_out.op == RESUMET) begin
                use_ucode <= True;
                ucode_pc = ucode_resumet_pc;
                pcu.change_pc(ucode_resumet_pc, ucode_resumet_dunder, ucode_resumet_dover);
                tmp_tp <= tp;
                dunder_tmp_tp <= dunder_tp;
                dover_tmp_tp <= dover_tp;
                new_tp <= unpack(pack(op1));
                dunder_new_tp <= op1_dunder;
                dover_new_tp <= op1_dover;
        end
        else if (decoder_out.op == YIELD) begin
                use_ucode <= True;
                ucode_pc = ucode_yield_pc;
                pcu.change_pc(ucode_yield_pc, ucode_yield_dunder, ucode_yield_dover);
                old_tp <= tp;
                tmp_tp <= ttt;
                new_tp <= ttt;
        end
        else if (decoder_out.op == YIELD2) begin
                use_ucode <= True;
                ucode_pc = ucode_yield2_pc;
                pcu.change_pc(ucode_yield2_pc, ucode_yield2_dunder, ucode_yield2_dover);
        end
        else if (decoder_out.op == TRANSEND) begin
                use_ucode <= True;
                ucode_pc = ucode_flush_pc;
                in_trans <= False;
                //need to keep pc inc for return from ucode
                state[valueOf(PC)] <= unpack(pack(pc) + 1);
                dunder_pc <= pcu.get_pc_dunder + 1;
                dover_pc <= pcu.get_pc_dover - 1;
                pcu.change_pc(ucode_flush_pc, ucode_flush_dunder, ucode_flush_dover);
        end
        else if (decoder_out.op == ENDU) begin
                use_ucode <= False;
                state[valueOf(TP)] <= unpack(pack(new_tp));
                dunder_tp <= dunder_new_tp;
                dover_tp <= dover_new_tp;
                tmp_tp <= new_tp;
                dunder_tmp_tp <= dunder_new_tp;
                dover_tmp_tp <= dover_new_tp;
                //change the pc to non-ucode pc
                pcu.change_pc(pc, dunder_pc, dover_pc);
        end
        else if (decoder_out.op == RETAGPC)
                pcu.retag_pc(op1.meta.tag); //need to properly increment pc
        else begin
                pcu.update_pc(bu.get_offset, pc_from_base); //update PC
                ucode_pc = unpack(extend(next_pc));
        end
        timer.set_slot(tpl_2(timer_out));	//update slot

        //put read request for next instruction
        imem0.a.put(False, next_pc >> 2, ?);
        imem1.a.put(False, next_pc >> 2, ?);
        imem2.a.put(False, next_pc >> 2, ?);
        imem3.a.put(False, next_pc >> 2, ?);
        ucode.a.put(False, ucode_pc.a, ?);

        if (!use_ucode) begin
                state[valueOf(TS)] <= unpack(extend(pack(ThreadStatus{thread_state: thread_state, error_code: error_code}))); //update thread status
                state[valueOf(MR)] <= curr_mr;
        end

        if ((next_pc == breakpoint_pc) && break_pc_set)
                proc_enabled <= False;

        //write to WB if within a transaction...
        if (in_trans) begin
                if ((decoder_out.op == CPRM) || (decoder_out.op == MVRM)) begin
                        Atom mw_tmp = op1;
                        mw_tmp.meta.tag = unpack(extend(pack(tmu_out.mwres)));
                        write_buffer.do_write(ma.a, mw_tmp);
                end
        end
        if (!use_ucode)
                cycle <= cycle + 1;
        if (break_cycle_set && !use_ucode)
                breakpoint_cycle <= breakpoint_cycle - 1;

        if (!use_ucode && (decoder_out.op != TRANSEND)) begin
                let tmp_pc = pcu.get_pc;
                tmp_pc.a = next_pc;
                if (decoder_out.op == RETAGPC)
                        tmp_pc.meta.tag = op1.meta.tag;
                state[valueOf(PC)] <= unpack(pack(tmp_pc));
        end
endrule

rule update_phase6 (phase == 6);
         phase <= 0;
endrule
