/************************************************************************************************
* Copyright  (c) 2011, 2012 University of Pennsylvania
*
* Permission to use, copy, modify, and distribute this software and
* its documentation for any purpose, without fee, and without a
* written agreement is hereby granted, provided that the above copyright
* notice and this paragraph and the following two paragraphs appear in
* all copies.
*
* IN NO EVENT SHALL THE UNIVERSITY OF PENNSYLVANIA BE LIABLE TO ANY PARTY FOR
* DIRECT, INDIRECT, SPECIAL, INCIDENTAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
* ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
* THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF PENNSYLVANIA
* HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
* THE UNIVERSITY OF PENNSYLVANIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
* AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE PROVIDED HEREUNDER IS ON
* AN "AS IS" BASIS, AND THE UNIVERSITY OF PENNSYLVANIA HAS NO OBLIGATIONS TO
* PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
***********************************************************************************************/

/************************************
Authors: Albert Kwon, Udit Dhawan
IC Group, Penn
************************************/

        rule decode_ctrl_signals (proc_enabled && (ts.thread_state != HALTED) &&
                                  !((breakpoint_cycle == 0) && break_cycle_set) &&
                                  (phase == 0));
                is_lcfp <= decoder_out_p0.op == LCFP;
                ptr_from_op2 <= ((decoder_out_p0.op == OFFP) || (decoder_out_p0.op == CPRM) || 
				(decoder_out_p0.op == MVRM) || (decoder_out_p0.op == STWY) || 
				(decoder_out_p0.op == GACALL) || (decoder_out_p0.op == GAJMP) ||
                                (decoder_out_p0.op == STWB));
                ptr_from_op3 <= ((decoder_out_p0.op == OFFLP) || (decoder_out_p0.op == OFFTP) ||
                                 (decoder_out_p0.op == GATE));
                ptr_from_op1 <= ((decoder_out_p0.op == STRB) || (decoder_out_p0.op == STRY) ||
                                 (decoder_out_p0.op == MVMR) || (decoder_out_p0.op == CPMR) ||
                                 (decoder_out_p0.op == CPMT) || (decoder_out_p0.op == CPAR) ||
                                 (decoder_out_p0.op == CPHR) || (decoder_out_p0.op == CPIO) ||
                                 (decoder_out_p0.op == GCALL) || (decoder_out_p0.op == GJMP));

		is_grtn <= decoder_out_p0.op == GRTN;
                is_framptr <= decoder_out_p0.op == FRAMPTR;
                is_cppm <= decoder_out_p0.op == CPPM;
                is_cpmp <= decoder_out_p0.op == CPMP;
                is_stream <= ((decoder_out_p0.op == STWB) || (decoder_out_p0.op == STWY) || 
                              (decoder_out_p0.op == STRB) || (decoder_out_p0.op == STRY));

                pc_changes <= ((decoder_out_p0.op == GCALL) || (decoder_out_p0.op == GACALL) ||
                               (decoder_out_p0.op == GJMP) || (decoder_out_p0.op == GAJMP) ||
                               (decoder_out_p0.op == GRTN) || (decoder_out_p0.op == CALL) ||
                               (decoder_out_p0.op == FJMP) || (decoder_out_p0.op == ENDU));
                is_gate_insn <= ((decoder_out_p0.op == GCALL) || (decoder_out_p0.op == GACALL) ||
                                 (decoder_out_p0.op == GJMP)  || (decoder_out_p0.op == GAJMP) ||
                                 (decoder_out_p0.op == GRTN) || (decoder_out_p0.op == BGCALL) || 
				 (decoder_out_p0.op == BGACALL) || (decoder_out_p0.op == BRTN));
		is_bracket_insn <= ((decoder_out_p0.op == BCALL) || (decoder_out_p0.op == BGCALL) || 
				    (decoder_out_p0.op == BGACALL) || (decoder_out_p0.op == BRTN));
                is_offset_ptr <= ((decoder_out_p0.op == OFFP) || (decoder_out_p0.op == OFFLP) ||
                                  (decoder_out_p0.op == OFFTP));
                is_inc_ptr <= ((decoder_out_p0.op == STWY) || (decoder_out_p0.op == STWB) ||
                               (decoder_out_p0.op == STRB) || (decoder_out_p0.op == STRY) ||
                               (decoder_out_p0.op == CPPM) || (decoder_out_p0.op == CPMP));

                from_base <= !((decoder_out_p0.op == OFFP) || (decoder_out_p0.op == OFFLP) ||
                               (decoder_out_p0.op == OFFTP) || (decoder_out_p0.op == GRTN) ||
                               (decoder_out_p0.op == CPMT) || (decoder_out_p0.op == CPAR) ||
                               (decoder_out_p0.op == CPHR) || (decoder_out_p0.op == CPIO) ||
                               (decoder_out_p0.op == CPMR) || (decoder_out_p0.op == CPRM) ||
                               (decoder_out_p0.op == MVMR) || (decoder_out_p0.op == MVRM) ||
                               (decoder_out_p0.op == GRTN) || (decoder_out_p0.op == STWY) ||
                               (decoder_out_p0.op == STWB) || (decoder_out_p0.op == STRB) ||
                               (decoder_out_p0.op == STRY) || (decoder_out_p0.op == CPMP) ||
                               (decoder_out_p0.op == CPPM));
                
                default_commit <= ((decoder_out_p0.op == ADD) || (decoder_out_p0.op == SUB) || (decoder_out_p0.op == AND) || (decoder_out_p0.op == OR) || 
		                   (decoder_out_p0.op == SHL) || (decoder_out_p0.op == SHR) || (decoder_out_p0.op == TEST) || (decoder_out_p0.op == MUL) || 
		                   (decoder_out_p0.op == FRAMPTR) || (decoder_out_p0.op == CPMR) || 
		                   (decoder_out_p0.op == CPMT) || (decoder_out_p0.op == CPAR) || (decoder_out_p0.op == CPHR) || (decoder_out_p0.op == CPIO ) || 
		                   (decoder_out_p0.op == MVMR) || (decoder_out_p0.op == MVRM) ||
		                   (decoder_out_p0.op == TOTAG) || (decoder_out_p0.op == RETAG) || (decoder_out_p0.op == SETTAG) || (decoder_out_p0.op == INTAG) || 
		                   (decoder_out_p0.op == INP) || (decoder_out_p0.op == INA) || (decoder_out_p0.op == MAKEP) || (decoder_out_p0.op == INGRP) || 
		                   (decoder_out_p0.op == STRY) || (decoder_out_p0.op == NEWG) || (decoder_out_p0.op == NEWT) || (decoder_out_p0.op == TMURC) ||
		                   (decoder_out_p0.op == RFLCT) || (decoder_out_p0.op == TAGOF) || (decoder_out_p0.op == FPHASH) ||
                                   (decoder_out_p0.op == RDTIME) || (decoder_out_p0.op == STRB) || (decoder_out_p0.op == TESTGRP) || (decoder_out_p0.op == LCFP));
                //$display("ctrl signals assigned");
        endrule


        rule read_enable (phase == 2);
                Bool ren_temp = (((decoder_out.op == CPRM) || (decoder_out.op == STWB)  ||
                                  (decoder_out.op == STWY) || (decoder_out.op == STRB)  ||
                                  (decoder_out.op == STRY) || (decoder_out.op == MVRM)  ||
                                  (decoder_out.op == MVMR) || (decoder_out.op == GCALL)  ||
                                  (decoder_out.op == GJMP) || (decoder_out.op == CPMR)  ||
                                  (decoder_out.op == GRTN) || (decoder_out.op == CPMT)  ||
                                  (decoder_out.op == CPAR) || (decoder_out.op == CPHR) ||
                                  (decoder_out.op == CPPM) || (decoder_out.op == CPMP) ||
				  (decoder_out.op == CPIO)) && (curr_ptr_wire.a[45] != 1) &&
                                 proc_enabled);
                ren_wire <= ren_temp;
                ren <= ren_temp;
                ////$display("read enable: %x", ren_temp);
        endrule


        rule write_enable (phase == 6);
                wen <= (((((error_code == NO_ERROR) && tmu_allow) && !in_trans &&
                          ((decoder_out.op == CPRM) || (decoder_out.op == STWB) ||
                           (decoder_out.op == STWY) || (decoder_out.op == STRB) ||
                           (decoder_out.op == STRY) || (decoder_out.op == MVRM) ||
                           (decoder_out.op == MVMR) || (decoder_out.op == GCALL) ||
                           (decoder_out.op == CALL) || (decoder_out.op == GACALL) ||
			   (decoder_out.op == BCALL) || (decoder_out.op == BGCALL) || 
			   (decoder_out.op == BGACALL) || (decoder_out.op == GATE)) && 
			  !su_block) || (decoder_out.op == CPPM)) && //cppm used for faults so error doesn't matter
                        proc_enabled && !in_trans);
        endrule

