/************************************************************************************************
* Copyright  (c) 2011, 2012 University of Pennsylvania
*
* Permission to use, copy, modify, and distribute this software and
* its documentation for any purpose, without fee, and without a
* written agreement is hereby granted, provided that the above copyright
* notice and this paragraph and the following two paragraphs appear in
* all copies.
*
* IN NO EVENT SHALL THE UNIVERSITY OF PENNSYLVANIA BE LIABLE TO ANY PARTY FOR
* DIRECT, INDIRECT, SPECIAL, INCIDENTAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
* ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
* THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF PENNSYLVANIA
* HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
* THE UNIVERSITY OF PENNSYLVANIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
* AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE PROVIDED HEREUNDER IS ON
* AN "AS IS" BASIS, AND THE UNIVERSITY OF PENNSYLVANIA HAS NO OBLIGATIONS TO
* PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
***********************************************************************************************/


import SAFETypes::*;
import Vector::*;

interface LVTIfc;
	method LVTOut lvt_lookup(ReadIndices in_addrs);
        method Action update_lvt(RF_A addr1, Bool wen1, RF_A addr2, Bool wen2);
endinterface

(*synthesize*)
module mkLVT(LVTIfc);

	Vector#(48, Reg#(Bit#(1))) lvt <- replicateM(mkReg(0));

	method LVTOut lvt_lookup(ReadIndices in_addrs);
		Bit#(1) out0 = lvt[in_addrs[0]];
		Bit#(1) out1 = lvt[in_addrs[1]];
		Bit#(1) out2 = lvt[in_addrs[2]];
		Bit#(1) out3 = lvt[in_addrs[3]];		
		return {out3, out2, out1, out0};
	endmethod

        method Action update_lvt(RF_A addr1, Bool wen1, RF_A addr2, Bool wen2);
		if (addr1 != addr2) begin
			lvt[addr1] <= wen1 ? 0 : lvt[addr1];
			lvt[addr2] <= wen2 ? 1 : lvt[addr2];
		end
        endmethod

endmodule
