/************************************************************************************************
* Copyright  (c) 2011, 2012 University of Pennsylvania
*
* Permission to use, copy, modify, and distribute this software and
* its documentation for any purpose, without fee, and without a
* written agreement is hereby granted, provided that the above copyright
* notice and this paragraph and the following two paragraphs appear in
* all copies.
*
* IN NO EVENT SHALL THE UNIVERSITY OF PENNSYLVANIA BE LIABLE TO ANY PARTY FOR
* DIRECT, INDIRECT, SPECIAL, INCIDENTAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
* ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
* THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF PENNSYLVANIA
* HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
* THE UNIVERSITY OF PENNSYLVANIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
* AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE PROVIDED HEREUNDER IS ON
* AN "AS IS" BASIS, AND THE UNIVERSITY OF PENNSYLVANIA HAS NO OBLIGATIONS TO
* PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
***********************************************************************************************/


import RFBank::*;
import SAFETypes::*;

interface MPRFIfc;
	method Action read_request(RF_A in_port0, RF_A in_port1, RF_A in_port2, RF_A in_port3);
	method Tuple2#(RFOut, RFOut)  do_read();
        method Action do_write_port1(RF_A out_port0, RegAtom val0);
        method Action do_write_port2(RF_A out_port1, RegAtom val1);
endinterface

(*synthesize*)
module mkMPRF(MPRFIfc);

   	RFBankIfc rf_bank0 <- mkRFBank;
	RFBankIfc rf_bank1 <- mkRFBank;
	
	method Action read_request(RF_A in_port0, RF_A in_port1, RF_A in_port2, RF_A in_port3);
		rf_bank0.read_request(in_port0, in_port1, in_port2, in_port3);
		rf_bank1.read_request(in_port0, in_port1, in_port2, in_port3);
	endmethod

	method Tuple2#(RFOut, RFOut) do_read();
		return tuple2(rf_bank0.do_read, rf_bank1.do_read);
	endmethod

	method Action do_write_port1(RF_A out_port0, RegAtom val0);
		rf_bank0.do_write(out_port0, val0);
	endmethod
        
        method Action do_write_port2(RF_A out_port1, RegAtom val1);
		rf_bank1.do_write(out_port1, val1);
	endmethod
        
endmodule
