/***************************************************
Match registers built for CAM
Authors: Udit Dhawan
IC Group, University of Pennsylvania

Last Updated: 02.14.2012
***************************************************/

import SAFETypes::*;

interface MatchItemIfc;
	method Bool do_match(A in_item);
	method Action write(A in_item);
	method A fetch_item();
	method Bool is_valid();
	method Action clear_item();
endinterface: MatchItemIfc


(* synthesize *)
module mkMatchItem(MatchItemIfc);

	Reg#(A) item <- mkReg(0);
	Reg#(Bool) valid <- mkReg(False);

	method Bool do_match(A in_item);
		Bool matched = False;

		if (in_item == item) begin
			matched = True;
		end

		return (matched && valid);
	endmethod

	method Action write(A in_item);
		item <= in_item;
		valid <= True;
	endmethod

	method A fetch_item();
		return item;
	endmethod

	method Bool is_valid();
		return valid;
	endmethod

	method Action clear_item();
		valid <= False;
	endmethod

endmodule
