        /*** Methods and Interfaces ***/
        method Action start() if (phase != 3);
                state[valueOf(TS)] <= unpack(extend(pack(ThreadStatus{thread_state: RUNNING, error_code: NO_ERROR})));
                FatPointer init_tp = FatPointer{meta: MetaData{ag: THREAD_POINTER, tag: unpack('h7a)}, m: 63, b: 0, i: 0, a: 'h0};
                let tmp_fpuout = fpu.decode(init_tp);
                dunder_tp <= tpl_1(tmp_fpuout);
                dover_tp <= tpl_2(tmp_fpuout);
                use_ucode <= True;
                state[valueOf(TP)] <= unpack(pack(init_tp));
                tmp_tp <= unpack(pack(init_tp));
                new_tp <= unpack(pack(init_tp));
                dunder_tmp_tp <= unpack(0);
                dover_tmp_tp <= unpack(63);
                dunder_new_tp <= unpack(0);
                dover_new_tp <= unpack(63);
                pcu.change_pc(ucode_boot_pc, ucode_boot_dunder, ucode_boot_dover);
                cycle <= 0;
                ucode.a.put(False, ucode_boot_pc.a, ?);
                //start bootstrapping the processor...
                booting <= True;
                phase <= 0;
                proc_enabled <= True;
                tmu.set_dc_tag('h902db);
                //the top module should also provide the value of QT, INIT_TP (anything else??)
        endmethod

        method Action enable_proc();
                proc_enabled <= True;
        endmethod

        method Action clear_breakpoint();
		break_cycle_set <= False;
		break_pc_set <= False;
        endmethod

        method Atom get_state(Bit#(32) control);
                case(control)
                        0: return unpack(extend(pack(cycle)));
                        1: return unpack(extend(pack(auth)));
                        2: return unpack(pack(pcu.get_pc));
                        3: return unpack(extend(pack(ci)));
                        4: return unpack(extend(pack(ren || wen)));
                        5: return unpack(pack(ma));
                        6: return unpack(pack(op1));
			7: return unpack(pack(op2));
			8: return unpack(pack(op3));
			9: return unpack(pack(mr));
			10: return unpack(extend(pack(ts)));
			11: return unpack(extend(pack(breakpoint_pc)));
                        12: return unpack(extend(pack(breakpoint_cycle)));
                        13: return unpack(extend(pack(proc_enabled)));
			14: return unpack(extend(pack(phase)));
                        15: return unpack(extend(pack(next_pc)));
                        16: return unpack(extend(pack(tp)));
                        17: return unpack(extend(pack(tpl_1(fpu_out))));
                        18: return unpack(pack(tpl_2(fpu_out)));
                        19: return unpack(extend(pack(tmp_tp)));
                        20: return unpack(extend(pack(pcu.in_bounds)));
                        default: return unpack(0);
                endcase
        endmethod

        method Action load_insn(A address, CacheLine insn);
                imem0.b.put(True, address, insn.a0);
                imem1.b.put(True, address, insn.a1);
                imem2.b.put(True, address, insn.a2);
                imem3.b.put(True, address, insn.a3);
        endmethod

        method Action load_reg(RF_A address, Atom val);
                rf.write_port1(address, RegAtom{atom: val, dunder:0, dover: 0});
        endmethod

        method Action load_ucode(A address, Atom val);
                ucode.b.put(True, address, val);
        endmethod
                
        method Action set_pc(FatPointer new_pc_host);
                pcu.load_pc(new_pc_host);
                //$display("not implemented atm");
        endmethod

        method Action set_bp_pc(A bp_pc);
                breakpoint_pc <= bp_pc;
                break_pc_set <= True;
        endmethod

        method Action set_bp_cycle(int bp_cycle);
                breakpoint_cycle <= bp_cycle;
                break_cycle_set <= True;
        endmethod

        method Bool halted();
                return unpack(truncate(pack(state[valueOf(TS)]))).thread_state == HALTED;
        endmethod

        method Action get_insn_req(A address);
                imem0.b.put(False, address, ?);
                imem1.b.put(False, address, ?);
                imem2.b.put(False, address, ?);
                imem3.b.put(False, address, ?);
        endmethod

        method CacheLine get_insn();
                return CacheLine{a0: unpack(pack(imem0.b.read)), a1: unpack(pack(imem1.b.read)), a2: unpack(pack(imem2.b.read)), a3: unpack(pack(imem3.b.read))};
        endmethod

        method Action get_reg_req(RF_A address);
                Vector#(4, RF_A) addr;
                addr[0] = address;
                addr[1] = address;
                addr[2] = address;
                addr[3] = address;
                rf.read_request(addr);
        endmethod

        method Atom get_reg();
                return rf_out.val0.atom;
        endmethod

        interface Client mem_rw;
                interface Get request;
                        method ActionValue#(BRAMRequest#(A, CacheLine)) get() if (ren_wire && (phase == 2));
                                //$display("Load addr: %x", curr_ptr_wire.a>>2);
                                return lsu.read_request(op, curr_ptr_wire.a>>2);
                        endmethod
                endinterface

                interface Put response;
                        method Action put(result) if (ren && (phase == 3));
                                curr_line <= result;
                                curr_line_wire <= result;
                                Atom curr_word;
                                if (index == 0)
                                        curr_word = result.a0;
                                else if (index == 1)
                                        curr_word = result.a1;
                                else if (index == 2)
                                        curr_word = result.a2;
                                else
                                        curr_word = result.a3;
                                curr_mr_wire <= curr_word;
                                //$display("Atom from memory: %x", curr_word);
                        endmethod
                endinterface
        endinterface

        interface Get store;
                method ActionValue#(BRAMRequest#(A, CacheLine)) get() if (wen && (phase == 6));
                        A a;
                        if (is_gate_insn || (decoder_out.op == BCALL) || (decoder_out.op == CALL))
                                a = gate_stack.get_gsp.a >> 2;
                        else
                                a = curr_ptr.a >> 2;
			if (a[43] != 1) begin
				Atom tmp_1 = curr_mw;
				if (decoder_out.op != CPPM)
					tmp_1.meta.tag = unpack(extend(tmu_out.mwres));

				if (decoder_out.op == MVMR) begin//clear the content in mem for mv
					tmp_1.meta.ag = EMPTY;
					tmp_1.payload = 0;
				end
				if ((decoder_out.op == STRY) || (decoder_out.op == STRB)) //reset ag to empty
					tmp_1.meta.ag = EMPTY;
				
				//combine the write value inside the curr_line
				CacheLine line_put;
				//TODO: CALL variants need EP to be uninitialized
				if (decoder_out.op == GATE)
					line_put = CacheLine{a0: op1, a1: curr_line.a1, a2: op2, 
							     a3: Atom{meta: MetaData{ag: ERROR, tag: public_tag}, payload: 0}};
				else if (is_bracket_insn)
					line_put = CacheLine{a0: unpack(pack(pc)+1), a1: unpack(pack(auth)), a2: unpack(pack(ep)),
							     a3: Atom{meta: MetaData{ag: INTEGER, tag: op3.meta.tag}, 
								payload: (extend(write_mask) << 32) | extend(pack(decoder_out.dest))}};
				else if (is_gate_insn)
					line_put = CacheLine{a0: unpack(pack(pc)+1), a1: unpack(pack(auth)), a2: unpack(pack(ep)), 
							     a3: Atom{meta: MetaData{ag: ERROR, tag: public_tag}, payload: 0}};
				else begin
					if (index == 0)
						line_put = CacheLine{a0: tmp_1, a1: curr_line.a1, a2: curr_line.a2, a3: curr_line.a3};
					else if (index == 1)
						line_put = CacheLine{a3: curr_line.a3, a2: curr_line.a2, a1: tmp_1, a0: curr_line.a0};
					else if (index == 2)
						line_put = CacheLine{a3: curr_line.a3, a2: tmp_1, a1: curr_line.a1, a0: curr_line.a0};
					else
						line_put = CacheLine{a3: tmp_1, a2: curr_line.a2, a1: curr_line.a1, a0: curr_line.a0};
				end
				//$display("curr_mw: %x", curr_mw);
				//$display("Store address: %x, atom: %x", a, line_put);
				return lsu.do_store(op, a, line_put);
			end
			else begin
				//e.tx_data(curr_mw, 69);
				return BRAMRequest {write: False, responseOnWrite: False, address: ?, datain: ?};
			end
                endmethod
        endinterface

        method Action load_hash_mem(Bit#(3) which, Bit#(9) addr, TMU_MR val);
               case(which)
                        0: tmu.care_mem_load(truncate(addr), unpack(truncate(pack(val))));
                        1: tmu.res_care_load(truncate(addr), unpack(truncate(pack(val))));
                        2: tmu.gnd_g1_load(truncate(addr), unpack(truncate(pack(val))));
                        3: tmu.gnd_g2_load(truncate(addr), unpack(truncate(pack(val))));
                        4: tmu.gnd_mr_load(truncate(addr), val);
               endcase
        endmethod

        method Action unload_tmu(Bit#(8) addr);
                tmu.tmu_unload(addr);
        endmethod

        method Action set_dc_tag(TAG_A new_tag);
		tmu.set_dc_tag(new_tag);
	endmethod