//concatenate the result
rule result_cat (proc_enabled && (phase == 6));

	let tmu_count = tmu.tmu_rc_read;
	case (decoder_out.op)
		ADD, SUB, OR, AND, SHR, SHL, TEST, MUL:
		result_atom <= Atom {meta: MetaData{ag: tpl_2(agu_out),
                                                    tag: unpack(extend(tmu_out.op3res))},
                                     payload: tpl_2(alu_out)};
		CPMR, MVMR, STRB, STRY:
		result_atom <= Atom{meta: MetaData{ag: curr_mr.meta.ag,
                                                   tag: unpack(extend(tmu_out.op3res))},
                                    payload: curr_mr.payload};
                CPMP: result_atom <= curr_mr;
		CPAR, CPHR:
		result_atom <= Atom{meta: MetaData{ag: tpl_2(agu_out),
                                                   tag: unpack(extend(tmu_out.op3res))},
                                    payload: curr_mr.payload};
		CPMT: begin
			      FatPointer fp = FatPointer{meta: MetaData{ag: tpl_2(agu_out),
                                                                        tag: unpack(extend(tmu_out.op3res))},
                                                         b: curr_mr.meta.tag.b, m: curr_mr.meta.tag.m,
                                                         i: 0, a: curr_mr.meta.tag.a}; //TODO: get i from a
			      result_atom <= unpack(pack(fp));
		      end
		TAGOF: begin
                               FatPointer fp = FatPointer{meta: MetaData{ag: tpl_2(agu_out),
                                                                         tag: op1.meta.tag},
                                                          b: op1.meta.tag.b, m: op1.meta.tag.m,
                                                          i: 0, a: op1.meta.tag.a}; //TODO: get ifrom a
			       result_atom <= unpack(pack(fp));
		       end
		RFLCT: begin
			       Tag tptag = op1.meta.tag;
			       result_atom <= Atom{meta: MetaData{ag: tpl_2(agu_out),
                                                                  tag: unpack(extend(tmu_out.op3res))},
                                                   payload: unpack(zeroExtend(pack(tptag)))};
		       end
		CPRR, MVRR, SETA: result_atom <= Atom{meta: MetaData{ag: tpl_2(agu_out),
                                                                     tag: unpack(extend(tmu_out.op3res))},
                                                      payload: op1.payload};
		CPIO: begin
			      Bit#(7) opc = truncate(pack(curr_mr.payload) >> 25);
			      result_atom <= Atom{meta: MetaData{ag: tpl_2(agu_out),
                                                                 tag: unpack(extend(tmu_out.op3res))},
                                                  payload: unpack(zeroExtend(pack(opc)))};
                      end
		MVRM: result_atom <= Atom{meta: MetaData{ag: UNINITIALIZED,
                                                         tag: unpack(extend(tmu_out.op1res))},
                                          payload: 0};
		MAKEP:result_atom <= Atom{meta: MetaData{ag: PRINCIPAL,
                                                         tag: unpack(extend(tmu_out.op3res))},
                                          payload: unpack(truncate(pack(op1)))};
		OFFP, OFFLP, OFFTP:
                begin
                        FatPointer fp = FatPointer{meta: MetaData{ag: tpl_2(fpu_out).meta.ag,
                                                                  tag: unpack(extend(tmu_out.op3res))},
                                                   i: tpl_2(fpu_out).i, b: tpl_2(fpu_out).b,
                                                   m: tpl_2(fpu_out).m, a: tpl_2(fpu_out).a};
		 	result_atom <= unpack(pack(fp));
		end
		FRAMPTR:result_atom <= Atom{meta: MetaData{ag: FR_POINTER,
                                                         tag: unpack(extend(tmu_out.op3res))},
                                          payload: curr_mr.payload};

		LCFP: begin
                              FatPointer fp = lcfp_ptr; fp.meta.tag = unpack(extend(tmu_out.op3res));
                              result_atom <= unpack(pack(fp));
                      end
		NEWG: result_atom <= Atom{meta: MetaData{ag: unpack(truncate(pack(op1.payload))),
                                                         tag: unpack(extend(tmu_out.op3res))},
                                          payload: op2.payload};
		NEWT: result_atom <= Atom{meta: MetaData{ag: tpl_2(agu_out),
                                                         tag: unpack(truncate(pack(op1.payload)))},
                                          payload: op2.payload};
		REGRP: result_atom <= Atom{meta: MetaData{ag: tpl_2(agu_out),
                                                          tag: unpack(extend(tmu_out.op3res))},
                                           payload: op3.payload};
		GATE: result_atom <= Atom{meta: MetaData{ag: tpl_2(agu_out),
                                                         tag: unpack(extend(tmu_out.op3res))},
                                          payload: op3.payload};
		GCALL, GACALL: result_atom <= Atom{meta: MetaData{ag: tpl_2(agu_out),
                                                                  tag: unpack(extend(tmu_out.op1res))},
                                                   payload: 0};
		INP, INA: result_atom <= Atom{meta: MetaData{ag: tpl_2(agu_out),
                                                             tag: unpack(extend(tmu_out.op3res))},
                                              payload: unpack(extend(pack(op1.payload)))};
		INGRP: result_atom <= Atom{meta: MetaData{ag: tpl_2(agu_out),
                                                          tag: unpack(extend(tmu_out.op3res))},
                                           payload: unpack(extend(pack(op1.meta.ag)))};
		INTAG: result_atom <= Atom{meta: MetaData{ag: tpl_2(agu_out),
                                                          tag: unpack(extend(tmu_out.op3res))},
                                           payload: unpack(extend(pack(op1.meta.tag)))};
		RETAG, SETTAG: result_atom <= Atom{meta: MetaData{ag: tpl_2(agu_out),
                                                                  tag: op1.meta.tag},
                                                   payload: op2.payload};
		TOTAG: result_atom <= Atom{meta: MetaData{ag: tpl_2(agu_out),
                                                          tag: unpack(truncate(pack(op1.payload)))},
                                           payload: unpack(0)};
		TMURC: result_atom <= Atom{meta: MetaData{ag: tpl_2(agu_out),
                                                          tag: unpack(extend(tmu_out.op3res))},
                                           payload: unpack(extend(pack(tmu_count)))};
		BRTN: result_atom <= Atom{meta: MetaData{ag: tpl_2(agu_out),
                                                          tag: unpack(extend(tmu_out.op1res))},
                                           payload: op1.payload};
		default: result_atom <= Atom{meta: MetaData{ag: tpl_2(agu_out),
                                                            tag: unpack(extend(tmu_out.op3res))},
                                             payload: 0};
	endcase

endrule

